package org.ow2.opensuit.samples.movies_db.uibeans;

import java.util.Locale;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.ow2.opensuit.core.session.OpenSuitSession;


public class UserConfig
{
	public Locale getLocale()
	{
		HttpServletRequest request = OpenSuitSession.getCurrentRequest();
		Cookie[] cookies = request.getCookies();
		for(int i=0; i<cookies.length; i++)
		{
			if(cookies[i].getName().equals("lang"))
			{
//				System.out.println("cookie found: "+cookies[i].getValue());
				return new Locale(cookies[i].getValue());
			}
		}
		
		// --- otherwise return default locale
//		System.out.println("cookie not found - use default language: "+request.getRequestURL().toString());
		return OpenSuitSession.getCurrentApplication().getAllLanguages()[0].getLocale();
	}
	public void setLocale(Locale locale)
	{
		HttpServletRequest request = OpenSuitSession.getCurrentRequest();
		HttpServletResponse response = OpenSuitSession.getCurrentResponse();
		Cookie langCookie = new Cookie("lang", locale.getLanguage());
		langCookie.setPath(request.getContextPath());
		response.addCookie(langCookie);
	}
}
